=== debian/watch ===
version=3
http://sf.net/b-o-s-s-a/bossa-x86_64-(.+)\.tgz
