=== debian/changelog ===
bossa (1.9.1-3ubuntu5) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:35:25 +1100

bossa (1.9.1-3ubuntu4) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 02:52:03 +0100

bossa (1.9.1-3ubuntu3) lunar; urgency=medium

  * No-change rebuild against wxwidgets 3.2.1

 -- Graham Inggs <ginggs@ubuntu.com>  Fri, 20 Jan 2023 13:18:10 +0000

bossa (1.9.1-3ubuntu2) lunar; urgency=medium

  * Fixup previous upload, adding two more uninitialized fixes to the patch
  * Forward patch upstream and to Debian
    https://github.com/shumatech/BOSSA/pull/165

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 12 Nov 2022 14:42:57 +0100

bossa (1.9.1-3ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/no-uninitialized-variables.patch: ensure all
      variables are provably initialized before use.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 08 Nov 2022 10:15:04 -0800

bossa (1.9.1-3) unstable; urgency=medium

  * Team upload.
  * Transition to wxWidgets 3.2 (Closes: #1019797)

 -- Scott Talbert <swt@techie.net>  Tue, 18 Oct 2022 19:41:34 -0400

bossa (1.9.1-2ubuntu1) jammy; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - debian/patches/no-uninitialized-variables.patch: ensure all
      variables are provably initialized before use.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 14 Dec 2021 08:36:19 -0800

bossa (1.9.1-2) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Andreas Tille <tille@debian.org>  Sun, 05 Dec 2021 21:07:50 +0100

bossa (1.9.1-1ubuntu1) focal; urgency=medium

  * debian/patches/no-uninitialized-variables.patch: ensure all
    variables are provably initialized before use.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 03 Mar 2020 16:14:13 -0800

bossa (1.9.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    Closes: #941138
  * Remove useless boilerplate from d/rules
  * Remove old desktop file
  * rebuild against wxWidgets GTK 3 package
    Closes: #933473
  * Point watch file to Github
  * debhelper-compat 12
  * Point Vcs fields to salsa.debian.org
  * Do not install README as upstream changelog

 -- Andreas Tille <tille@debian.org>  Fri, 04 Oct 2019 23:41:12 +0200

bossa (1.3~20120408-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Apply patch from upstream git to fix FTBFS with GCC7 (Closes: #853338)

 -- Andreas Moog <andreas.moog@warperbbs.de>  Sat, 30 Sep 2017 12:42:31 +0200

bossa (1.3~20120408-5) unstable; urgency=low

  [ Olly Betts ]
  * Update to use wxWidgets 3.0 (new patch: wx3.0-compat.patch)
    Closes: #751554
  * debian/control: Fix typo in bossa package description.

 -- Scott Howard <showard@debian.org>  Sun, 15 Jun 2014 20:53:24 -0400

bossa (1.3~20120408-4) unstable; urgency=low

  * Updated bossac manpage, thanks to Karl Lenz (Closes: #737280)

 -- Scott Howard <showard@debian.org>  Fri, 07 Mar 2014 11:18:01 -0500
