=== debian/control ===
Source: bossa
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Scott Howard <showard@debian.org>
Section: electronics
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libwxgtk3.2-dev,
               libreadline6-dev,
               libx11-dev,
               imagemagick
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/bossa
Vcs-Git: https://salsa.debian.org/science-team/bossa.git
Homepage: https://www.shumatech.com/web/products/bossa
Rules-Requires-Root: no

Package: bossa
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: extra-xdg-menus
Description: Atmel SAM ARM microcontroller flash programming GUI
 BOSSA is a flash programming utility for Atmel's SAM family of flash-based ARM
 microcontrollers.  The motivation behind BOSSA is to create a simple, easy-to-
 use, open source utility to replace Atmel's SAM-BA software.
 .
 This package contains the wxWidgets GUI interface to bossa.

Package: bossa-cli
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Atmel SAM ARM microcontroller flash programming utility
 BOSSA is a flash programming utility for Atmel's SAM family of flash-based ARM
 microcontrollers.  The motivation behind BOSSA is to create a simple, easy-to-
 use, open source utility to replace Atmel's SAM-BA software.
 .
 This package contains the BOSSA command line interface and interactive shell
 (i.e., bossac and bossash).
