=== debian/watch ===
version=4

https://github.com/shumatech/BOSSA/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
